define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	require("cordova!com.synconset.imagepicker");
	var ImagesZoom = require("plugin/scale");
	
	var Model = function(){
		this.callParent();
		this.id = 0;
		this.ownerID = 'DEAL' + justep.Date.toString(new Date(), 'yyyyMM');
		this.user = $.parseJSON(justep.Util.getCookie("user"));
	};
	
	Model.prototype.modelLoad = function(event){
		// 初始化商品图片大图展示
		ImagesZoom.init({ "elem" : (".showBigImgClass"), "rootdom" : this.getElementByXid("panel1") });
	};	
	
	
	Model.prototype.modelParamsReceive = function(event){
		this.id =  event.params.id;
		this.ownerID = 'DEAL' + justep.Date.toString(new Date(), 'yyyyMM');
		this.user = $.parseJSON(justep.Util.getCookie("user"));
		var dataComp = this.comp("dataIncident");
		justep.Baas.sendRequest({
			'url' : '/nkyz/incident',
			"action" : "getIncidentDetail",
			"async" : true,
			"params" : {id:this.id},
			'success' : function(data) {
				if(data.ok){
					var incident = data.bean;
					if(incident.state == 4){
						justep.Util.hint("该事件已经处理，请手动刷新事件列表！");
						justep.Shell.closePage();
					}
					dataComp.loadData([incident], false);
					dataComp.last();
				}else{
					justep.Util.hint(data.errorMsg);
				}
			}
		});
	};	
	
	//拍照图片
	Model.prototype.button1Click = function(event){
		var $divUploadImages = $(this.getElementByXid("divUploadImages"));
		function onSuccess(imageURI) {
			window.resolveLocalFileSystemURI(imageURI, function(entry) {
				console.log(entry);
				var arr = entry.name.split(".");
				var imgname = (new justep.UUID()).valueOf() + '.' + arr[arr.length-1];
				entry.file(function(file) {
		            var reader = new FileReader();
		            reader.onloadend = function(e) {
		                var aRemove = '<a class="x-remove-barget" onclick="javascript:$(this).parent().remove();"></a>';
		            	var imghtml = '<div class="weui_uploader_image_div"><img class="weui_uploader_image" src="' 
		            		+ entry.toInternalURL()+ '" onclick="javascript:void(0);" imgname="'+ imgname 
		            		+ '" base64str="' + e.target.result +'"></img>' + aRemove + '</div>';
		            	$divUploadImages.prepend(imghtml);
		            };
		            reader.readAsDataURL(file);
		        }, function(e) {
		        	justep.Util.hint("读写出现异常: " + e.message);
		        })
			}, function() {
				justep.Util.hint("打开图片出现异常！");
			});
		}
		function onFail(message) {
			justep.Util.hint(message);
		}
		navigator.camera.getPicture(onSuccess, onFail, {
			quality : 50,
			sourceType : 1 // 0、2为从相册文件中选择，1为拍照
		});
	};	
	
	//图库选择图片
	Model.prototype.button2Click = function(event){
		var $divUploadImages = $(this.getElementByXid("divUploadImages"));
		document.addEventListener("deviceready", androidOnDeviceReady, false);
		function androidOnDeviceReady() {
			imagePicker.getPictures(androidSuccessCallback, errorCallback, {
				"maximumImagesCount" : 20,//最大图片选择数量
				"width" : 1000,//图片的高度和宽度限定,如果都写成0，则按照图片大小显示，不为0且大于该值则进行等比例压缩
				"height" : 1000,
				"quallity" : 100,//图片质量，取值为0-100
				"outputType" : 0//导出图片的类型，默认为FILE_URI(实际值为0)，BASE64_STRING (实际值为1)
			});
		}
		function androidSuccessCallback(result) {
			if (result.length > 0) {
				for (var i = 0; i < result.length; i++) {
					window.resolveLocalFileSystemURI(result[i], function(entry) {
						console.log(entry);
						var arr = entry.name.split(".");
						var imgname = (new justep.UUID()).valueOf() + '.' + arr[arr.length-1];
						entry.file(function(file) {
				            var reader = new FileReader();
				            reader.onloadend = function(e) {
				            	var aRemove = '<a class="x-remove-barget" onclick="javascript:$(this).parent().remove();"></a>';
				            	var imghtml = '<div class="weui_uploader_image_div"><img class="weui_uploader_image" src="' 
				            		+ entry.toInternalURL()+ '" onclick="javascript:void(0);" imgname="'+ imgname 
				            		+ '" base64str="' + e.target.result +'"></img>' + aRemove + '</div>';
				            	$divUploadImages.prepend(imghtml);
				            };
				            reader.readAsDataURL(file);
				        }, function(e) {
				        	justep.Util.hint("读写出现异常: " + e.message);
				        })
					}, function() {
						justep.Util.hint("打开图片出现异常！");
					});
				}
			} else {
				console.log("没有选择图片");
			}
		}
		function errorCallback(error) {
			justep.Util.hint("错误信息: " + JSON.stringify(error));
		}
	};	
	
	//提报处理
	Model.prototype.button4Click = function(event){
		var self = this;
		var description = self.comp("suggestTextarea").val();
		if(!description){
			justep.Util.hint("请填写处理文字描述！");
			return;
		}
		self.popOverZz = self.comp("popOverZz");//遮罩
		self.popOverZz.show();
		//上传图片数据封装
		var $imgs = $(this.getElementByXid("divUploadImages")).find("img.weui_uploader_image");
		var imageUrlsArr = [];
		for(var i=0; i<$imgs.length; i++){
			var $img = $imgs.eq(i);
			var imageData = $img.attr("base64str");
			var imageName = $img.attr("imgname");
			var params = {
				"imageName" : imageName,
				"imageData" : imageData,
				"ownerID" : self.ownerID
			};
			imageUrlsArr.push(params);
		}
		//保存
		justep.Baas.sendRequest({
			"url" : "/nkyz/incident", 
			"action" : "saveIncidentDeal",
			"async" : true,
			"params" : { description:description, imageUrlsArr:imageUrlsArr, id:self.id, username:self.user.username },
			"success" : function(data) {
				self.popOverZz.hide();//关闭遮罩
				if(data.ok){
					justep.Util.hint("处理提交成功！请手动刷新事件列表！");
					justep.Shell.closePage();
				}else{
					justep.Util.hint(data.errorMsg);
				}
			}
		});
	};	
	

	return Model;
});